/*
 *  Fcalc - a touch-screen calculator for the GP2X-F200
 *  written (at a tube) by flynn@vtech.fr
 *  source GPL'ed    
 */     
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <dlfcn.h>

#include <SDL/SDL.h>


void *SDL_handle = NULL;

void libSDL_open()
{
  if (SDL_handle == NULL)
  {
    void *handle = dlopen("libSDL.so", RTLD_LAZY);
    if (!handle) {
      fprintf(stderr, "%s\n", dlerror());
      exit(EXIT_FAILURE);
    }
  }
}

void libSDL_close()
{
  if (SDL_handle != NULL) dlclose(SDL_handle) ;
  SDL_handle = NULL ;
}

#define Q(string) # string

#define VSDLDEF0(SDLname) \
void (*pSDL_##SDLname)(void) = NULL ; \
void SDL_##SDLname(void) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pSDL_##SDLname)(); \
}

#define VSDLDEF1(SDLname, SDLarg) \
void (*pSDL_##SDLname)(SDLarg) = NULL ; \
void SDL_##SDLname(SDLarg arg1) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pSDL_##SDLname)(arg1); \
}

#define SDLDEF0(SDLret, SDLname) \
SDLret (*pSDL_##SDLname)(void) = NULL ; \
SDLret SDL_##SDLname(void) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pSDL_##SDLname)(); \
}
#define SDLDEF1(SDLret, SDLname, SDLarg) \
SDLret (*pSDL_##SDLname)(SDLarg) = NULL ; \
SDLret SDL_##SDLname(SDLarg arg1) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pSDL_##SDLname)(arg1); \
}

#define SDLDEF2(SDLret, SDLname, SDLarg1, SDLarg2) \
SDLret (*pSDL_##SDLname)(SDLarg1, SDLarg2) = NULL ; \
SDLret SDL_##SDLname(SDLarg1 arg1, SDLarg2 arg2) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pSDL_##SDLname)(arg1, arg2); \
}

#define SDLDEF3(SDLret, SDLname, SDLarg1, SDLarg2, SDLarg3) \
SDLret (*pSDL_##SDLname)(SDLarg1, SDLarg2, SDLarg3) = NULL ; \
SDLret SDL_##SDLname(SDLarg1 arg1, SDLarg2 arg2, SDLarg3 arg3) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pSDL_##SDLname)(arg1, arg2, arg3); \
}

#define SDLDEF4(SDLret, SDLname, SDLarg1, SDLarg2, SDLarg3, SDLarg4) \
SDLret (*pSDL_##SDLname)(SDLarg1, SDLarg2, SDLarg3, SDLarg4) = NULL ; \
SDLret SDL_##SDLname(SDLarg1 arg1, SDLarg2 arg2, SDLarg3 arg3, SDLarg4 arg4) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pSDL_##SDLname)(arg1, arg2, arg3, arg4); \
}

#define VSDLDEF5(SDLname, SDLarg1, SDLarg2, SDLarg3, SDLarg4, SDLarg5) \
void (*pSDL_##SDLname)(SDLarg1, SDLarg2, SDLarg3, SDLarg4, SDLarg5) = NULL ; \
void SDL_##SDLname(SDLarg1 arg1, SDLarg2 arg2, SDLarg3 arg3, SDLarg4 arg4, SDLarg5 arg5) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pSDL_##SDLname)(arg1, arg2, arg3, arg4, arg5); \
}

#define SDLDEF8(SDLret, SDLname, SDLarg1, SDLarg2, SDLarg3, SDLarg4, \
	SDLarg5, SDLarg6, SDLarg7, SDLarg8) \
SDLret (*pSDL_##SDLname)(SDLarg1, SDLarg2, SDLarg3, SDLarg4, \
	SDLarg5, SDLarg6, SDLarg7, SDLarg8) = NULL ; \
SDLret SDL_##SDLname(SDLarg1 arg1, SDLarg2 arg2, SDLarg3 arg3, SDLarg4 arg4, \
	SDLarg5 arg5, SDLarg6 arg6, SDLarg7 arg7, SDLarg8 arg8) \
{ \
  if (pSDL_##SDLname == NULL) \
  { \
    char *error; \
    libSDL_open() ; \
    dlerror(); \
    pSDL_##SDLname = dlsym(SDL_handle, Q(SDL_##SDLname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pSDL_##SDLname)(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8); \
}

VSDLDEF0(Quit) ;
SDLDEF0(char*, GetError) ;
SDLDEF1(int, Init, unsigned int) ;
SDLDEF1(int, ShowCursor, int) ;
SDLDEF1(SDL_Joystick*, JoystickOpen, int) ;
SDLDEF1(int, PollEvent, SDL_Event*) ;
VSDLDEF1(FreeSurface, SDL_Surface*) ;
SDLDEF1(int, LockSurface, SDL_Surface*) ;
SDLDEF1(int, Flip, SDL_Surface*) ;
SDLDEF2(Uint8, GetMouseState, int*, int*) ;
SDLDEF2(SDL_RWops*, RWFromFile, const char*, const char*) ;
SDLDEF2(SDL_Surface*, LoadBMP_RW, SDL_RWops*, int) ;
VSDLDEF1(UnlockSurface, SDL_Surface*) ;
SDLDEF3(int, SetColorKey, SDL_Surface*, Uint32, Uint32) ;
SDLDEF3(int, SetAlpha, SDL_Surface*, Uint32, Uint8) ;
SDLDEF3(int, FillRect, SDL_Surface*, SDL_Rect*, Uint32) ;
SDLDEF4(int, UpperBlit, SDL_Surface*, SDL_Rect*, SDL_Surface*, SDL_Rect*) ;
SDLDEF4(Uint32, MapRGB, SDL_PixelFormat*, Uint8, Uint8, Uint8) ;
SDLDEF4(int, SetColors, SDL_Surface*, SDL_Color*, int, int) ;
SDLDEF4(SDL_Surface*, SetVideoMode, int, int, int, Uint32) ;
VSDLDEF5(UpdateRect, SDL_Surface*, Sint32, Sint32, Uint32, Uint32) ;
SDLDEF8(SDL_Surface*, CreateRGBSurface, Uint32, int, int, int, Uint32, Uint32, Uint32, Uint32) ;
