/*
 *  Fcalc - a touch-screen calculator for the GP2X-F200
 *  written (at a tube) by flynn@vtech.fr
 *  source GPL'ed    
 */     
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <dlfcn.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>


void *TTF_handle = NULL;

void libTTF_open()
{
  if (TTF_handle == NULL)
  {
    void *handle = dlopen("libSDL_ttf.so", RTLD_LAZY);
    if (!handle) {
      fprintf(stderr, "%s\n", dlerror());
      exit(EXIT_FAILURE);
    }
  }
}

void libTTF_close()
{
  if (TTF_handle != NULL) dlclose(TTF_handle) ;
  TTF_handle = NULL ;
}

#define Q(string) # string

#define VTTFDEF0(TTFname) \
void (*pTTF_##TTFname)(void) = NULL ; \
void TTF_##TTFname(void) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pTTF_##TTFname)(); \
}

#define VTTFDEF1(TTFname, TTFarg) \
void (*pTTF_##TTFname)(TTFarg) = NULL ; \
void TTF_##TTFname(TTFarg arg1) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pTTF_##TTFname)(arg1); \
}

#define TTFDEF0(TTFret, TTFname) \
TTFret (*pTTF_##TTFname)(void) = NULL ; \
TTFret TTF_##TTFname(void) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pTTF_##TTFname)(); \
}
#define TTFDEF1(TTFret, TTFname, TTFarg) \
TTFret (*pTTF_##TTFname)(TTFarg) = NULL ; \
TTFret TTF_##TTFname(TTFarg arg1) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pTTF_##TTFname)(arg1); \
}

#define TTFDEF2(TTFret, TTFname, TTFarg1, TTFarg2) \
TTFret (*pTTF_##TTFname)(TTFarg1, TTFarg2) = NULL ; \
TTFret TTF_##TTFname(TTFarg1 arg1, TTFarg2 arg2) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pTTF_##TTFname)(arg1, arg2); \
}

#define TTFDEF3(TTFret, TTFname, TTFarg1, TTFarg2, TTFarg3) \
TTFret (*pTTF_##TTFname)(TTFarg1, TTFarg2, TTFarg3) = NULL ; \
TTFret TTF_##TTFname(TTFarg1 arg1, TTFarg2 arg2, TTFarg3 arg3) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pTTF_##TTFname)(arg1, arg2, arg3); \
}

#define TTFDEF4(TTFret, TTFname, TTFarg1, TTFarg2, TTFarg3, TTFarg4) \
TTFret (*pTTF_##TTFname)(TTFarg1, TTFarg2, TTFarg3, TTFarg4) = NULL ; \
TTFret TTF_##TTFname(TTFarg1 arg1, TTFarg2 arg2, TTFarg3 arg3, TTFarg4 arg4) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pTTF_##TTFname)(arg1, arg2, arg3, arg4); \
}

#define VTTFDEF5(TTFname, TTFarg1, TTFarg2, TTFarg3, TTFarg4, TTFarg5) \
void (*pTTF_##TTFname)(TTFarg1, TTFarg2, TTFarg3, TTFarg4, TTFarg5) = NULL ; \
void TTF_##TTFname(TTFarg1 arg1, TTFarg2 arg2, TTFarg3 arg3, TTFarg4 arg4, TTFarg5 arg5) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  (*pTTF_##TTFname)(arg1, arg2, arg3, arg4, arg5); \
}

#define TTFDEF8(TTFret, TTFname, TTFarg1, TTFarg2, TTFarg3, TTFarg4, \
	TTFarg5, TTFarg6, TTFarg7, TTFarg8) \
TTFret (*pTTF_##TTFname)(TTFarg1, TTFarg2, TTFarg3, TTFarg4, \
	TTFarg5, TTFarg6, TTFarg7, TTFarg8) = NULL ; \
TTFret TTF_##TTFname(TTFarg1 arg1, TTFarg2 arg2, TTFarg3 arg3, TTFarg4 arg4, \
	TTFarg5 arg5, TTFarg6 arg6, TTFarg7 arg7, TTFarg8 arg8) \
{ \
  if (pTTF_##TTFname == NULL) \
  { \
    char *error; \
    libTTF_open() ; \
    dlerror(); \
    pTTF_##TTFname = dlsym(TTF_handle, Q(TTF_##TTFname) ); \
    if ((error = dlerror()) != NULL)  { \
       fprintf(stderr, "%s\n", error); \
       exit(EXIT_FAILURE); \
    } \
  } \
  return (*pTTF_##TTFname)(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8); \
}


TTFDEF0(int, Init) ;
VTTFDEF1(CloseFont, TTF_Font *) ;
TTFDEF2(TTF_Font *, OpenFont, const char *, int) ;
TTFDEF3(SDL_Surface*, RenderText_Blended, TTF_Font*, const char *, SDL_Color) ;
